## pytorch-audio 2.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)

# Most of the configurations are taken from PyTorch
# https://github.com/pytorch/pytorch/blob/0c9fb4aff0d60eaadb04e4d5d099fb1e1d5701a9/CMakeLists.txt

# Use compiler ID "AppleClang" instead of "Clang" for XCode.
# Not setting this sometimes makes XCode C compiler gets detected as "Clang",
# even when the C++ one is detected as "AppleClang".
cmake_policy(SET CMP0010 NEW)
cmake_policy(SET CMP0025 NEW)

# Suppress warning flags in default MSVC configuration.  It's not
# mandatory that we do this (and we don't if cmake is old), but it's
# nice when it's possible, and it's possible on our Windows configs.
if(NOT CMAKE_VERSION VERSION_LESS 3.15.0)
  cmake_policy(SET CMP0092 NEW)
endif()

# Suppress warning about ExternalProject_Add timestamp
if(NOT CMAKE_VERSION VERSION_LESS 3.24.0)
  cmake_policy(SET CMP0135 OLD)
endif()

project(torchaudio)


# check and set CMAKE_CXX_STANDARD
string(FIND "${CMAKE_CXX_FLAGS}" "-std=c++" env_cxx_standard)
if(env_cxx_standard GREATER -1)
  message(
      WARNING "C++ standard version definition detected in environment variable."
      "PyTorch requires -std=c++17. Please remove -std=c++ settings in your environment.")
endif()
set(CMAKE_CXX_STANDARD 17 CACHE STRING "The C++ standard whose features are requested to build this target.")
set(CMAKE_C_STANDARD   11 CACHE STRING "The C standard whose features are requested to build this target.")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Apple specific
if(APPLE)
  # Get clang version on macOS
  execute_process( COMMAND ${CMAKE_CXX_COMPILER} --version OUTPUT_VARIABLE clang_full_version_string )
  string(REGEX REPLACE "Apple LLVM version ([0-9]+\\.[0-9]+).*" "\\1" CLANG_VERSION_STRING ${clang_full_version_string})
  message( STATUS "CLANG_VERSION_STRING:         " ${CLANG_VERSION_STRING} )

  # RPATH stuff
  set(CMAKE_MACOSX_RPATH ON)

  set(CMAKE_SHARED_LIBRARY_SUFFIX ".so")
endif()


# Options
option(BUILD_SOX "Build libsox statically" ON)
option(BUILD_RIR "Enable RIR simulation" ON)
option(BUILD_RNNT "Enable RNN transducer" ON)
option(BUILD_ALIGN "Enable forced alignment" ON)
option(BUILD_CUDA_CTC_DECODER "Build CUCTC decoder" OFF)
option(BUILD_TORCHAUDIO_PYTHON_EXTENSION "Build Python extension" OFF)
option(USE_FFMPEG "Enable ffmpeg-based features" OFF)
option(USE_CUDA "Enable CUDA support" OFF)
option(USE_ROCM "Enable ROCM support" OFF)
option(USE_OPENMP "Enable OpenMP support" OFF)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# check that USE_CUDA and USE_ROCM are not set at the same time
if(USE_CUDA AND USE_ROCM)
  message(FATAL "CUDA and ROCm are mutually exclusive")
endif()

if(USE_ROCM)
  # Find the HIP package, set the HIP paths, load the HIP CMake.
  include(cmake/LoadHIP.cmake)
  if(NOT PYTORCH_FOUND_HIP)
    set(USE_ROCM OFF)
  endif()
endif()

if(USE_CUDA)
  enable_language(CUDA)
  set(
    CMAKE_CUDA_FLAGS
    "${CMAKE_CUDA_FLAGS} \
    -DCUDA_HAS_FP16=1 \
    -D__CUDA_NO_HALF_OPERATORS__ \
    -D__CUDA_NO_HALF_CONVERSIONS__ \
    -D__CUDA_NO_HALF2_OPERATORS__"
  )
endif()

include(cmake/TorchAudioHelper.cmake)

# https://github.com/pytorch/pytorch/issues/54174
function(CUDA_CONVERT_FLAGS EXISTING_TARGET)
    get_property(old_flags TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS)
    if(NOT "${old_flags}" STREQUAL "")
        string(REPLACE ";" "," CUDA_flags "${old_flags}")
        set_property(TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS
            "$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CXX>>:${old_flags}>$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CUDA>>:-Xcompiler=${CUDA_flags}>"
            )
    endif()
endfunction()

if(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")
  if(USE_CUDA)
    set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -Xcompiler=/wd4819")
    foreach(diag cc_clobber_ignored integer_sign_change useless_using_declaration
      set_but_not_used field_without_dll_interface
      base_class_has_different_dll_interface
      dll_interface_conflict_none_assumed
      dll_interface_conflict_dllexport_assumed
      implicit_return_from_non_void_function
      unsigned_compare_with_zero
      declared_but_not_referenced
      bad_friend_decl)
      string(
        APPEND
        CMAKE_CUDA_FLAGS
        " -Xcudafe \
        --diag_suppress=${diag} \
        -DCUDA_HAS_FP16=1 \
        -D__CUDA_NO_HALF_OPERATORS__ \
        -D__CUDA_NO_HALF_CONVERSIONS__ \
        -D__CUDA_NO_HALF2_OPERATORS__"
      )
    endforeach()
    CUDA_CONVERT_FLAGS(torch_cpu)
    if(TARGET torch_cuda)
      CUDA_CONVERT_FLAGS(torch_cuda)
    endif()
    if(TARGET torch_cuda_cu)
      CUDA_CONVERT_FLAGS(torch_cuda_cu)
    endif()
    if(TARGET torch_cuda_cpp)
      CUDA_CONVERT_FLAGS(torch_cuda_cpp)
    endif()
  endif()
endif()

if(USE_OPENMP)
  find_package(OpenMP REQUIRED)
endif()

# TORCH_CXX_FLAGS contains the same -D_GLIBCXX_USE_CXX11_ABI value as PyTorch
if (MSVC)
  set(warning_flags /W4)
  # the following line is added in order to export symbols when building on Windows
  # this approach has some limitations as documented in https://github.com/pytorch/pytorch/pull/3650
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
else()
  set(warning_flags -Wall)
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${warning_flags} ${TORCH_CXX_FLAGS}")

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
  message(STATUS "Found ccache")
  set(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
  set(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
  set(CMAKE_CUDA_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
else()
  message(STATUS "Could not find ccache. Consider installing ccache to speed up compilation.")
endif()

add_subdirectory(src/libtorchaudio)
if (BUILD_SOX)
  add_subdirectory(third_party/sox)
  add_subdirectory(src/libtorchaudio/sox)
endif()
if (USE_FFMPEG)
  if (DEFINED ENV{FFMPEG_ROOT})
    add_subdirectory(third_party/ffmpeg/single)
  else()
    message(STATUS "Building FFmpeg integration with multi version support")
    add_subdirectory(third_party/ffmpeg/multi)
  endif()
  add_subdirectory(src/libtorio/ffmpeg)
endif()
if (BUILD_CUDA_CTC_DECODER)
  if (NOT USE_CUDA)
    message(FATAL "BUILD_CUDA_CTC_DECODER=1 but USE_CUDA=0.")
  endif()
  add_subdirectory(src/libtorchaudio/cuctc)
endif()
if (BUILD_CPP_TEST)
  add_subdirectory(test/cpp)
endif()

=== requirements.txt ===
# Minimum runtime dependencies
torch

# Optional runtime dependencies
kaldi_io
SoundFile

# For build and test-time dependencies please refer to CONTRIBUTING.md

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = torchaudio
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

docset: html
	doc2dash --name $(SPHINXPROJ) --icon $(SOURCEDIR)/_static/img/pytorch-logo-flame.png --enable-js --online-redirect-url http://pytorch.org/audio/ --force $(BUILDDIR)/html/

	# Manually fix because Zeal doesn't deal well with `icon.png`-only at 2x resolution.
	cp $(SPHINXPROJ).docset/icon.png $(SPHINXPROJ).docset/icon@2x.png
	convert $(SPHINXPROJ).docset/icon@2x.png -resize 16x16 $(SPHINXPROJ).docset/icon.png

.PHONY: help Makefile docset

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	doxygen source/Doxyfile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	@python post_process_dispatcher.py $(BUILDDIR)

clean:
	rm -rf $(BUILDDIR)/*
	rm -rf $(SOURCEDIR)/generated/
	rm -rf $(SOURCEDIR)/aen_images/
	rm -rf $(SOURCEDIR)/gen_modules/

=== docs/requirements.txt ===
Jinja2<3.1.0
matplotlib<=3.8
pyparsing<3,>=2.0.2

# C++ docs
breathe==4.34.0

# Note:
# When changing Sphinx-related packages, make sure that the custom behaviors in the following
# locations are working as expected.
# - source/_templates/layout.html
# - source/_static/css/custom.css
-e git+https://github.com/pytorch/pytorch_sphinx_theme.git@32a6550#egg=pytorch_sphinx_theme
sphinx==5.1.1
sphinxcontrib.katex==0.8.6
sphinxcontrib.bibtex==2.4.2
sphinx_gallery==0.11.1
nbsphinx==0.8.8

# https://github.com/bmcfee/resampy/issues/106
# Since 2022-07-07 build_docs CI job started to fail.
# Pinning resampy to 0.2.2 resolves this.
# The real cause is not know at the moment but the use
# of librosa seems to cause this
# https://github.com/bmcfee/resampy/issues/106
# In our case, the tutorial timed out is online_asr_tutorial,
# which itself does not use resampy
# However audio_feature_augmentation_tutorial is executed before that,
# which uses librosa.
resampy==0.2.2

=== examples/libtorchaudio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libtorchaudio-cpp-example)

SET(BUILD_SOX ON CACHE BOOL "Build libsox into libtorchaudio")

SET(BUILD_KALDI OFF CACHE BOOL "Build Kaldi into libtorchaudio")
SET(BUILD_RNNT ON CACHE BOOL "Build RNN transducer into libtorchaudio")
SET(BUILD_TORCHAUDIO_PYTHON_EXTENSION OFF CACHE BOOL "Build Python binding")

find_package(Torch REQUIRED)
message("libtorchaudio CMakeLists: ${TORCH_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TORCH_CXX_FLAGS}")

add_subdirectory(../.. libtorchaudio)
add_subdirectory(augmentation)
add_subdirectory(speech_recognition)

=== src/libtorchaudio/CMakeLists.txt ===
################################################################################
# libtorchaudio
################################################################################
set(
  sources
  lfilter.cpp
  overdrive.cpp
  utils.cpp
  )

set(
  additional_libs
  )

set(
  compile_definitions)

#------------------------------------------------------------------------------#
# START OF CUSTOMIZATION LOGICS
#------------------------------------------------------------------------------#
if(BUILD_RNNT)
  list(
    APPEND
    sources
    rnnt/cpu/compute_alphas.cpp
    rnnt/cpu/compute_betas.cpp
    rnnt/cpu/compute.cpp
    rnnt/compute_alphas.cpp
    rnnt/compute_betas.cpp
    rnnt/compute.cpp
    rnnt/autograd.cpp
    )
  if (USE_CUDA)
    list(
      APPEND
      sources
      rnnt/gpu/compute_alphas.cu
      rnnt/gpu/compute_betas.cu
      rnnt/gpu/compute.cu
      )
  endif()
endif()

if(BUILD_RIR)
  list(APPEND sources rir/rir.cpp rir/ray_tracing.cpp)
  list(APPEND compile_definitions INCLUDE_RIR)
endif()

if(BUILD_ALIGN)
  list(
    APPEND
    sources
    forced_align/compute.cpp
    forced_align/cpu/compute.cpp
  )
  list(APPEND compile_definitions INCLUDE_ALIGN)
  if (USE_CUDA)
    list(
      APPEND
      sources
      forced_align/gpu/compute.cu
    )
  endif()
endif()

if(USE_CUDA)
  list(
    APPEND
    sources
    iir_cuda.cu
  )
  list(
    APPEND
    additional_libs
    cuda_deps
    )
endif()

if(OpenMP_CXX_FOUND)
  list(
    APPEND
    additional_libs
    OpenMP::OpenMP_CXX
    )
endif()

#------------------------------------------------------------------------------#
# END OF CUSTOMIZATION LOGICS
#------------------------------------------------------------------------------#

torchaudio_library(
  libtorchaudio
  "${sources}"
  ""
  "torch;${additional_libs}"
  "${compile_definitions}"
  )

if (APPLE)
  set(TORCHAUDIO_LIBRARY libtorchaudio CACHE INTERNAL "")
else()
  set(TORCHAUDIO_LIBRARY -Wl,--no-as-needed libtorchaudio -Wl,--as-needed CACHE INTERNAL "")
endif()

################################################################################
# Python extensions
################################################################################
if (BUILD_TORCHAUDIO_PYTHON_EXTENSION)
  set(
    extension_sources
    pybind/pybind.cpp
    )
  torchaudio_extension(
    _torchaudio
    "${extension_sources}"
    ""
    "libtorchaudio"
    ""
    )
endif()

=== test/cpp/CMakeLists.txt ===
include(FetchContent)
FetchContent_Declare(
  googletest
  URL https://github.com/google/googletest/archive/refs/tags/v1.14.0.zip
)

# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)

enable_testing()

add_executable(
  wall_collision
  rir/wall_collision.cpp
)
target_link_libraries(
  wall_collision
  torch
  GTest::gtest_main
)
target_include_directories(
  wall_collision
  PRIVATE
  "${PROJECT_SOURCE_DIR}/src"
)
add_test(NAME wall_collision_test COMMAND wall_collision)

=== third_party/sox/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
  sox_src
  URL https://downloads.sourceforge.net/project/sox/sox/14.4.2/sox-14.4.2.tar.bz2
  URL_HASH SHA256=81a6956d4330e75b5827316e44ae381e6f1e8928003c6aa45896da9041ea149c
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  )
# FetchContent_MakeAvailable will parse the downloaded content and setup the targets.
# We want to only download and not build, so we run Populate manually.
if(NOT sox_src_POPULATED)
  FetchContent_Populate(sox_src)
endif()

add_library(sox SHARED stub.c)
if(APPLE)
  set_target_properties(sox PROPERTIES SUFFIX .dylib)
endif(APPLE)
target_include_directories(sox PUBLIC ${sox_src_SOURCE_DIR}/src)

=== examples/avsr/data_prep/requirements.txt ===
tqdm
scikit-image
opencv-python
ffmpeg-python

=== examples/libtorchaudio/augmentation/CMakeLists.txt ===
add_executable(augment main.cpp)
target_link_libraries(augment "${TORCH_LIBRARIES}" "${TORCHAUDIO_LIBRARY}")
set_property(TARGET augment PROPERTY CXX_STANDARD 14)

=== src/libtorchaudio/cuctc/CMakeLists.txt ===
# Custom CMakeLists for building cuda ctc decoder

set(CMAKE_CXX_VISIBILITY_PRESET default)

# the following line is added in order to export symbols when building on Windows
# this approach has some limitations as documented in https://github.com/pytorch/pytorch/pull/3650
if (MSVC)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

set(
  libctc_prefix_decoder_src
  src/ctc_prefix_decoder.cpp
  src/ctc_prefix_decoder_kernel_v2.cu
  )

set(
  additional_libs
  )

list(
  APPEND
  additional_libs
  cuda_deps
  )

torchaudio_library(
  libctc_prefix_decoder
  "${libctc_prefix_decoder_src}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${additional_libs}"
  ""
  )

if (BUILD_TORCHAUDIO_PYTHON_EXTENSION)
  torchaudio_extension(
    pybind11_prefixctc
    src/python_binding.cpp
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "libctc_prefix_decoder;${additional_libs}"
    ""
    )
endif()

=== src/libtorchaudio/sox/CMakeLists.txt ===
set(
  sources
  io.cpp
  utils.cpp
  effects.cpp
  effects_chain.cpp
  types.cpp
  )
torchaudio_library(
  libtorchaudio_sox
  "${sources}"
  ""
  "torch;sox"
  ""
  )

if (BUILD_TORCHAUDIO_PYTHON_EXTENSION)
  torchaudio_extension(
    _torchaudio_sox
    "pybind/pybind.cpp;"
    ""
    "libtorchaudio_sox"
    ""
    )
endif()

=== debian/changelog ===
pytorch-audio (2.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.6.0 (closes: #1071137)
  * d/patches:
    + refresh patches to use sox and ffmpeg from system
    + update metadata for buildsystem-fixups.patch
    + add patch to make build reproducible (closes: #1036522)
  * d/{control,rules}:
    + bump std-ver to 4.7.0 (no changes required)
    + update B-D version and replace obsolete pkg-config with pkgconf
    + build only for default Python (required by pytorch, now 3.13)
    + explicitly disable ffmpeg plugin due to lack of upstream support
  * d/copyright: remove superfluous or unused content, update some file paths
  * Generate correct dependency on pytorch variants (closes: #1077500)

 -- Shengqi Chen <harry@debian.org>  Mon, 03 Mar 2025 20:40:11 +0800

=== debian/control ===
Source: pytorch-audio
Section: science
Homepage: https://github.com/pytorch/audio
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-audio.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-audio
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-python,
#               libavdevice-dev,
#               libavcodec-dev,
#               libavfilter-dev,
#               libavformat-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libsox-dev,
               libtorch-dev (>= 2.6.0~),
               ninja-build,
               pkgconf,
               pybind11-dev,
               python3,
               python3-dev,
               python3-parameterized <!nocheck>,
               python3-pytest <!nocheck>,
               python3-scipy <!nocheck>,
               python3-setuptools,
               python3-torch (>= 2.6.0~),

Package: python3-torchaudio
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Data manipulation and transformation for audio signal processing
 The aim of torchaudio is to apply PyTorch to the audio domain. By supporting
 PyTorch, torchaudio follows the same philosophy of providing strong GPU
 acceleration, having a focus on trainable features through the autograd system,
 and having consistent style (tensor names and dimension names). Therefore, it
 is primarily a machine learning library and not a general signal processing
 library. The benefits of Pytorch is be seen in torchaudio through having all
 the computations be through Pytorch operations which makes it easy to use and
 feel like a natural extension.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# upstream does not support ffmpeg7, disable it
export USE_FFMPEG=0
# export FFMPEG_ROOT=/usr

%:
	dh $@ -Spybuild --with python3

override_dh_auto_clean:
	-dh_auto_clean

execute_after_dh_clean:
	-$(RM) -vf src/torchaudio/version.py
	-$(RM) -r build/ torchaudio.egg-info/ .pybuild/

#execute_after_dh_install:
	#find . -name *_torchaudio.so* -exec \
	#	patchelf --replace-needed libtorchaudio.so lib/libtorchaudio.so {} \;

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_auto_test:
	-dh_auto_test

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-audio-$1.tar.gz%" \
https://github.com/pytorch/audio/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
